
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Scala基础：面向对象&mdash;&mdash;类 / 憋错料</title>

    <meta name="description" content="Scala基础：面向对象&mdash;&mdash;类 类 (class) 类是对象的模板,通过构造类,能够使用new关键字声明一系列同结构的对象. Scala的一个源文件可以包含多个public类. 声明Person类: class Person{   var name : String = _   val age = 10   private[this] val gender = &quot;male&quot; } 说明: name字段被赋值为&quot;_&quot;&quot;_&quot;即占位符.表示name被声明为String.但赋值 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Scala基础：面向对象&mdash;&mdash;类</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h4>类 (class)</h4>
<p>类是对象的模板，通过构造类，能够使用new关键字声明一系列同结构的对象。</p>
<p>Scala的一个源文件可以包含多个public类。</p>
<p>声明Person类：</p>
<p>class Person{</p>
<p>&#160; var name : String = _</p>
<p>&#160; val age = 10</p>
<p>&#160; private[this] val gender = “male”</p>
<p>}</p>
<p>说明：</p>
<p>name字段被赋值为“_”“_”即占位符。表示name被声明为String。但赋值为“_”，即暂不赋实际的值。</p>
<p>若使用占位符，Scala无法判断name的类型，所以必须声明该字段的类型。</p>
<p>gender 在Person中“private[this]” 限定住了，在类的外部无法被调用。</p>
<p>Scala构造器</p>
<p>Scala构造器与Java构造器有很大的不同。Scala中的构造器分为主构造器与副构造器。</p>
<p>主构造器</p>
<p>Scala中每个类都有主构造器，且与类定义交织在一起。</p>
<p>Scala主构造器的参数直接放置在类名之后。</p>
<p>一个类若没有显式定义主构造器，则自动拥有一个无参主构造器。</p>
<p>例：主构造器的声明。</p>
<p>class Person(val name: String, var age: Int) {</p>
<p>&#160; // ...</p>
<p>}</p>
<p>Scala类中没有放在方法体的语句都会被执行。</p>
<p>例：主构造器的方法体。</p>
<p>class Person(val name: String, var age: Int) {</p>
<p>&#160; println(&quot;This is primary constrator!&quot;)</p>
<p>}</p>
<p>主构造器的参数被编译成字段，并在构造对象时初始化传入。</p>
<p>例：</p>
<p>object PersonMain{</p>
<p>def main(args: Array[String]) {</p>
<p>val p = new Person(&quot;Tom&quot;,18);</p>
<p>&#160;&#160;&#160; println(&quot;p is &quot;+ p.name + &quot;,&quot; + p.age )</p>
<p>&#160; }</p>
<p>}</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMC5jbmJsb2dzLmNvbS9ibG9nLzQ1MzM2MS8yMDE1MDYvMjkyMjExMzQ5NjI3MTUzLmpwZw==.jpg" /></p>
<p>输出：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMC5jbmJsb2dzLmNvbS9ibG9nLzQ1MzM2MS8yMDE1MDYvMjkyMjExMzU5MTUxNjk4LmpwZw==.jpg" /></p>
<p>例：</p>
<p>class Person(val name: String, var age: Int) {</p>
<p>&#160; println(“Person is created”)</p>
<p>&#160; val id = name + &quot;:&quot; + age</p>
<p>}</p>
<p>val p = new Person(“Tom” , 18)</p>
<p>说明：</p>
<p>Person类拥有三个字段name，age，id 。</p>
<p>主构造器的参数一般有四种：</p>
<p>value: String</p>
<p>对象的不可变私有字段，对象中没有方法使用value，则没有该字段。即相当于private[this] val 。</p>
<p>private val value: String 或 private var value: String</p>
<p>对象的私有字段，私有的getter/setter方法。</p>
<p>val/var value：String</p>
<p>对象的私有字段，公有的getter/setter方法。</p>
<p>@BeanProperty val/var value：String</p>
<p>私有字段，共有的Scala和JavaBean的getter/setter方法</p>
<p>私有主构造器</p>
<p>class HelloWorld private(主构造器){ 类成员 }</p>
<p>主构造器私有，只能通过辅助构造器构造对象。</p>
<p>副构造器（辅助构造器）</p>
<p>Scala类能有任意多的副构造器。</p>
<p>Scala的副构造器都以“this”为名称，在类中定义。</p>
<p>例：</p>
<p>class Person(var name: String, val age: Int) {</p>
<p>&#160; println(&quot;this is primary constrator!&quot;)</p>
<p>var gender: String = _</p>
<p>def this(name: String, age: Int, gender: String) {</p>
<p>this(name, age)</p>
<p>this.gender = gender</p>
<p>&#160; }</p>
<p>}</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMC5jbmJsb2dzLmNvbS9ibG9nLzQ1MzM2MS8yMDE1MDYvMjkyMjExMzcwODc4NTM3LmpwZw==.jpg" /></p>
<p>输出：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMC5jbmJsb2dzLmNvbS9ibG9nLzQ1MzM2MS8yMDE1MDYvMjkyMjExMzgyNzQ1MzA5LmpwZw==.jpg" /></p>
<p>副构造器中必须调用主构造器或调用其他副构造器，而其他副构造器中必须调用主构造器。也即所有副构造器中必须有一个调用主构造器。</p>
<p>录：</p>
<p>class HelloWorld{</p>
<p>&#160; private var value1 = ””</p>
<p>&#160; private var value2 = ””</p>
<p>&#160; def this(m:String) {</p>
<p>&#160;&#160;&#160; this()&#160;&#160;&#160;&#160; //调用主构造器</p>
<p>&#160;&#160;&#160; this.value1=m</p>
<p>&#160; }</p>
<p>&#160; def this(m:String,n:String) {</p>
<p>&#160;&#160;&#160; this(m)&#160;&#160;&#160; //调用已定义的辅助构造器</p>
<p>&#160;&#160;&#160; this.value2=n</p>
<p>&#160; }</p>
<p>}</p>
<p>辨析：构造器与函数</p>
<p>主构造器的参数允许带有val/var关键字，函数的参数不能带有这些关键字。</p>
<p>主构造器的参数允许带有val/var关键字，副构造器的参数不能带有这些关键字。</p>
<h4>Scala Object</h4>
<p>Scala中没有static的概念。但Scala中使用object提供类似的功能。</p>
<p>单例对象</p>
<p>object语法定义了的类的单实例。</p>
<p>object Accounts{</p>
<p>&#160; private var lastNum = 0</p>
<p>&#160; def newUniqueNum = {</p>
<p>&#160;&#160;&#160; lastNum += 1</p>
<p>&#160;&#160;&#160; lastNum</p>
<p>&#160; }</p>
<p>}</p>
<p>object中的方法，即可以被当作为静态方法。</p>
<p>调用object中的方法，直接调用，不用new。</p>
<p>Accounts.newUniqueNum ()</p>
<p>对象的构造器在该对象第一次被使用时调用。</p>
<p>object语法结构与class大致相同，除了object不能提供构造器参数。</p>
<p>通常使用单例对象的环境：</p>
<p>&#160;&#160;&#160; 作为存放工具函数或常量的地方。</p>
<p>&#160;&#160;&#160; 共享单个不可变实例。</p>
<p>&#160;&#160;&#160; 利用单个实例协调某个服务。</p>
<p>伴生对象</p>
<p>Java中存在既有实例方法又有静态方法的类。在Scala中可以通过类与类的伴生对象来达到同样的目的。</p>
<p>当一个单例对象存在同名类的时候，称为伴生对象。</p>
<p>class Account{...}&#160; //伴生类</p>
<p>object Account{...}&#160; //伴生对象</p>
<p>类和其伴生对象可以互相访问私有属性，但必须存在同一个源文件中。</p>
<p>类的伴生对象可以被访问，但并不在作用域中。</p>
<p>例：</p>
<p>class Account{...}</p>
<p>object Account{ def newUniqueNum = {...} }</p>
<p>HelloWorld类必须通过Account.newUniqueNum()调用伴生对象中的newUniqueNum()方法，而不能直接用newUniqueNum()来调用。</p>
<p>伴生对象也是扩展类功能的一种途径。因为伴生类可以直接使用伴生对象的方法。</p>
<p>apply方法</p>
<p>apply方法专用于简化创建类实例的方法。apply方法类似于工厂方法。当需要构造有参数需求的伴生对象时，通常会定义和使用对象的apply方法。apply方法返回伴生类的对象。</p>
<p>当遇到如下形式的表达式时，apply方法就会被调用：Object(参数1, ... ,参数N)</p>
<p>例：Spark源码中Graph对象。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMC5jbmJsb2dzLmNvbS9ibG9nLzQ1MzM2MS8yMDE1MDYvMjkyMjExMzk4NjgzMDIzLmpwZw==.jpg" /></p>
<p>GraphImpl方法也是一个Object对象。</p>
<p>例：Array对象定义了apply方法，则可以用如下表达式来创建数组：</p>
<p>Array(“Mary”,”had”,”a”,”little”,”lamb”)</p>
<p>辨析：</p>
<p>Array(100) 返回的是拥有1个元素的数组。元素值为100。</p>
<p>new Array(100) 返回的是拥有100个元素的数组。每个元素值为null。</p>
<p>例：</p>
<p>class ApplyOperation{}</p>
<p>class ApplyTest{</p>
<p>&#160; def haveTry{</p>
<p>&#160;&#160;&#160; println(“Have a try on apply!”)</p>
<p>&#160; }</p>
<p>}</p>
<p>object ApplyTest{</p>
<p>&#160; def apply() = new ApplyTest</p>
<p>}</p>
<p>object ApplyOperation extends App {</p>
<p>&#160; val a = ApplyTest()</p>
<p>&#160; a.haveTry</p>
<p>}</p>
<p>例：</p>
<p>class HelloWorld(var m:String,n:Char){...}</p>
<p>object HelloWorld{</p>
<p>&#160;&#160;&#160; def apply(n：Char)=new HelloWorld(“ ”，n)</p>
<p>}</p>
<p>val hi=HELLOWORLD(‘j’)</p>
<p>例：</p>
<p>class Account private(val id:Int,initialBalance:Double){</p>
<p>&#160; private var balance = initialBalance</p>
<p>}</p>
<p>object Account{</p>
<p>&#160; def apply(initialBalance:Double) = new Account(newUniqueNum ,initialBalance)</p>
<p>}</p>
<p>构造账号对象：</p>
<p>val acct = Account(1000.0)</p>
<p>class中使用apply方法</p>
<p>apply方法一般只使用于object。class中也可以使用，但不常用。</p>
<p>例：</p>
<p>class ApplyOperation{}</p>
<p>class ApplyTest{</p>
<p>def apply() = &quot;apply in class&quot;</p>
<p>def haveTry{</p>
<p>&#160;&#160;&#160; println(&quot;Have a try on apply!&quot;)</p>
<p>&#160; }</p>
<p>}</p>
<p>object ApplyTest{</p>
<p>def apply() = new ApplyTest</p>
<p>}</p>
<p>object ApplyOperation extends App {</p>
<p>val a = new ApplyTest</p>
<p>val applyStr = a();</p>
<p>&#160; println(applyStr)</p>
<p>}</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMC5jbmJsb2dzLmNvbS9ibG9nLzQ1MzM2MS8yMDE1MDYvMjkyMjExNDA2OTY4MTM2LmpwZw==.jpg" /></p>
<p>输出：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMC5jbmJsb2dzLmNvbS9ibG9nLzQ1MzM2MS8yMDE1MDYvMjkyMjExNDEyNDM2MDM2LmpwZw==.jpg" /></p>
<h4>Scala继承</h4>
<p>继承是类的拓展。</p>
<p>extends是Scala中实现继承的保留字：</p>
<p>class week extends month{...}</p>
<p>说明：</p>
<p>week类继承了month类所有非私有成员。</p>
<p>week类是month类的子类，month类是week类的超类。</p>
<p>子类能重写超类的成员（具有相同名称和参数）。</p>
<p>例：</p>
<p>class Student(name:String , age:Int ,val major : String) extends Person(name , age) {</p>
<p>&#160; println(“this is subclass of Person , major is :” + major)</p>
<p>}</p>
<p>单例对象同样能从类中继承，与类的继承语法相同：</p>
<p>object day extends week{...}</p>
<p>单例对象是否能被继承呢？</p>
<p>重写</p>
<p>Scala中使用override保留字进行方法、字段重写</p>
<p>class week extends month{</p>
<p>override def firstday = {...}</p>
<p>}</p>
<p>override保留字实际使用类似与private，声明这个保留字后的定义、声明是对超类的重写，因此，其也可以写在类定义的参数中</p>
<p>class week(override val lastday：String) extends month{...}</p>
<p>子类的重写或修改Scala会检查其超类，但是，超类的修改并不会检查其子类</p>
<p>例：</p>
<p>class Student(name:String , age:Int ,val major : String) extends Person(name , age) {</p>
<p>&#160; println(“this is subclass of Person , major is :” + major)</p>
<p>&#160; override def toSting = “override toSting”</p>
<p>}</p>
<p>重写包括字段和方法，但参数不同的方法可以不重写</p>
<p>class month{ def secondday（m:String）={...}}</p>
<p>class week extends month{ def secondday ={...}}</p>
<p>规则：</p>
<p>重写 def</p>
<p>用val ：利用val能重写超类用没有参数的方法(getter)</p>
<p>用def：子类的方法与超类方法重名</p>
<p>用var：同时重写getter、setter方法，只重写getter方法报错</p>
<p>重写val</p>
<p>用val：子类的一个私有字段与超类的字段重名，getter方法重写超类的getter方法</p>
<p>重写var</p>
<p>用var：且当超类的var是抽象的才能被重写，否则超类的var都会被继承</p>
<p>例：</p>
<p>class month{</p>
<p>&#160; val one = 25 //可在子类中用val重写</p>
<p>&#160; var two = 15 //不可在子类中用var重写，因为不是抽象的</p>
<p>&#160; var three：Int</p>
<p>&#160; def firstday =&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160; //可在子类中用val重写</p>
<p>&#160; def now =&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160; //可在子类中用var重写</p>
<p>&#160; def now_ =&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;</p>
<p>&#160; def lastday(m:Char)={}&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160; //可在子类中用def重写</p>
<p>}</p>
<p>总结：</p>
<p>子类中，def只能重写超类的def，val能重写超类的val或不带参数的def，var只能重写超类中抽象的var或者超类的getter/setter对。</p>
<p>匿名子类</p>
<p>val alien = new Person(“Fred”){</p>
<p>&#160; def greeting = “Greetings , Earthling! My name is Fred”</p>
<p>}</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 06:16:50 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Scala基础：面向对象&mdash;&mdash;类的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49OX5D0.html" rel="bookmark">黑马程序员-Java基础-面向对象-类和对象、封装、构造函数、this、static、饿汉式&amp;amp&semi;懒汉式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第一讲  面向对象概念 1.  定义 相对于与面向过程而言的,将功能封装进对象,我们只关心具备了该功能的对象,而不用关注对象的具体细节. 面向对象的特点:使复杂问题简单化.我们只关心什么对象能处理什么事情,而不用关心具体的实现细节. 2.  面向对象特征 封装.继承.多态. 第二讲  类和对象的关系 1.  概述 类就是:对现实生活中事物的描述,可以是实体的事物也可以是一件事等: 对象是:是某类事物的实例,实实在在存在的个体: 映射到java中,描述就是class定义的类. 具体对象就是对应ja			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0d9z5z3.html" rel="bookmark">附录A培训实习生-面向对象基础&lpar;1&rpar;&colon;类和实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				对象是一个自包含的实体,用一组可识别的特性和行为来标识. 面向对象编程,Object-Oriented Programming,其实就是针对对象进行编程的意思. 类就是具有相同属性和功能的对象的抽象的集合. 在编程过程中注意: 第一,类名称首字母记着要大写.多个单词则各个首字母大写. 第二,对外公开的方法需要用public修饰符. 实例,就是一个真实的对象. 实例化就是创建对象的过程,使用new关键字来创建. 下面是一个例子: 这是一个类, 1 using System; 2 using Sys			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEWlnP3.html" rel="bookmark">&lbrack;&period;net 面向对象编程基础&rsqb; &lpar;9&rpar; 类的成员（字段、属性、方法）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[.net 面向对象编程基础] (9) 类的成员(字段.属性.方法) 前面定义的Person的类,里面的成员包括:字段.属性.方法.事件等,此外,前面说的嵌套类也是类的成员. a.类的成员为分:静态成员(static)和非静态成员 b.静态成员用static标识,不标识则默认为非静态成员 c.静态成员属于类所有,动态成员则属于实例所有,即对象 d.静态成员为类所有实例共享,无论类有多少实例或副本,静态成员只占用存中一块区域.非静态成员则在类的每个实例,都创建一个内存域. 下面主要说明一下类的主要			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41yAov4.html" rel="bookmark">Java基础知识：面向对象&amp;类图</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				类(Class)封装了数据和行为,是面向对象的重要组成部分,它是具有相同属性.操作.关系的对象集合的总称.在系统中,每个类都具有一定的职责,职责指的是类要完成什么样的功能,要承担什么样的义务.一个类可以有多种职责,设计得好的类一般只有一种职责.在定义类的时候,将类的职责分解成为类的属性和操作(即方法).类的属性即类的数据职责,类的操作即类的行为职责.设计类是面向对象设计中最重要的组成部分,也是最复杂和最耗时的部分. 1.面向对象特性 1)抽象 2)继承 3)封装 4)多态 2.类图: 在软件系统			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZKNQD4.html" rel="bookmark">图解Python 【第五篇】：面向对象-类-初级基础篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				由于类的内容比较多,分为类-初级基础篇和类-进阶篇 类的内容总览图: 本节内容一览图: 今天只讲类的基础的面向对象的特性 前言总结介绍: 面向对象是一种编程方式,此编程方式的实现是基于对 类 和 对象 的使用 类 是一个模板,模板中包装了多个&quot;函数&quot;供使用(可以讲多函数中公用的变量封装到对象中) 对象,根据模板创建的实例(即:对象),实例用于调用被包装在类中的函数,对象是一个类的实例 实例(instance):一个对象的实例化实现. 标识(identity):每个对象的实例都需要一个可			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bjRQp0.html" rel="bookmark">&lbrack;Scala基础系列 06&rsqb;Scala类和对象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.类和构造函数 Scala中的类,基本概念与其他面向对象语言是一致的,不过在语法上有些不一样的地方.与Java等语言相比,Scala的类语法更简洁,使用起来也更方便. 1.1.类的基本语法 我们先来看一个简单的类定义和使用的代码. class ScoreCalculator { private var total, count = 0 def report(score: Int) { total += score count += 1 } def score = if (count == 0)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pKjxy3.html" rel="bookmark">Scala笔记整理（三）：Scala面向对象&mdash;类详解1</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[TOC] getter和setter 简单类和无参方法 需要说明的是,官方给出的参考资料对于这方面讲解得十分详细,目前入门来说,不需要达到这样的理解,只需要可以进行开发即可,这一部分我给出的是官方的一些文档说明,但是后面的定制和注解,就直接简单说明能用就好了. class PersonOps { private var age = 0 //你必须初始化一个字段 def increment() {age += 1} //方法默认是公有的 def currentAge() = age } 1)在S			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MG7bKAM.html" rel="bookmark">Spark入门到精通视频学习资料--第一章、Scala基础与实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第一章.Scala基础与实践(3讲) Scala编程语言抓住了很多开发者的眼球.如果你粗略浏览Scala的网站,你会觉得Scala是一种纯粹的面向对象编程语言,而又无缝地结合了命令式和函数式的编程风格. 根据David Rupp在博客中的说法,Scala可能是下下一代Java. Scala有几项关键特性表明了它的面向对象的本质.例如,Scala中的每个值都是一个对象,包括基本数据类型(即布尔值.数字等)在内,连函数也是对象.另外,类可以被子类化,而且Scala还提供了基于mixin的组合(mix			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmzWmp0.html" rel="bookmark">【Scala学习之一】 Scala基础语法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				环境 虚拟机:VMware 10 Linux版本:CentOS-6.5-x86_64 客户端:Xshell4 FTP:Xftp4 jdk1.8 scala-2.10.4(依赖jdk1.8) spark-1.6 Scala是一种混合功能编程语言,类似java,运行于JVM,集成面向对象编程和函数式编程的各种特性.(1)Scala可以与Java互操作:它用scalac这个编译器把源文件编译成Java的class文件,从Scala中调用所有的Java类库,也同样可以从Java应用程序中调用Scala的			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q0xB7B4.html" rel="bookmark" class="title">精益开发实战&mdash;&mdash;用看板管理大型项目  读书笔记</a>
					<div>
						1.项目背景 2.组织团队 3.每天出席鸡尾酒会 上面的会议通常持续10-15分钟,由团队主管(ScrumMaster)主持,一般问就下面3个问题展开. 我昨天做了什么工作? 今天打算做什么? 遇到了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pvbEx0.html" rel="bookmark" class="title">NodeJS Multiple Callback解决之使用Q Promises</a>
					<div>
						在上一篇&lt;Javascript Promises模式--相当酷的Callback Hell终结者&gt;我们介绍了Javascript的Promise模式,接着我们就把Javascript Pr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVgdlx0.html" rel="bookmark" class="title">A Simple MVC Framework With Node and Express</a>
					<div>
						I love frameworks. As soon as I dropped my programmer's ego and learned to embrace well conceived co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/412rAgM.html" rel="bookmark" class="title">ubuntu ibus开机启动设置</a>
					<div>
						安装ubuntu, 开机默认输入法是不启动ibus, 所以每次自己手动启动输入法.很是麻烦: 以下是解决方法:方法一.  System &gt;&gt; Administration &gt;&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QNgWBM.html" rel="bookmark" class="title">第一次冲刺总结</a>
					<div>
						在这个冲刺里,我们组员经过商量一致通过了做点餐APP的决定.其中,每个人扮演的角色都不一样,各个角色都不可或缺,每一个角色的付出才能拼合成我们的团队的灵魂,每个组员相互配合才能打造出如今的团队.其中, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j5Nj7M.html" rel="bookmark" class="title">制作一个日历程序</a>
					<div>
						calendar.class.php &lt;?php date_default_timezone_set('PRC'); class Calendar{ private $year; //当前的年  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/My5dOEM.html" rel="bookmark" class="title">数的hash；</a>
					<div>
						1.数的哈希一般是讲较大的数转化为一定范围内的数,如112131321321 转化为100000以内,一般用%99991:就是自己构造hash函数,然后函数值在100000以内: 2.当出现相同的ke ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Jz2pP4.html" rel="bookmark" class="title">Linux Red hat 5  DNS服务器搭建（一）域名缓存服务器</a>
					<div>
						Linux Red hat 5 DNS服务器多实验详细搭建 所需软件包: ? bind-9.3.3-7.el5.i386.rpm ? 提供主要程序及相关文件 ? bind-utils-9.3.3-7. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/415gNX4.html" rel="bookmark" class="title">用C&plus;&plus;画心（转）</a>
					<div>
						原地址https://www.zhihu.com/topic/19613730/top-answers 首先上一个动态的心 代码如下: 1 #include &lt;stdio.h&gt; 2 #in ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NGWoGM.html" rel="bookmark" class="title">vue2入坑随记&lpar;一&rpar;</a>
					<div>
						都说Vue2简单,上手容易,但小马过河,自己试了才晓得,除了ES6语法和webpack的配置让你感到陌生,重要的是思路的变换,以前随便拿全局变量和修改dom的锤子不能用了,变换到关注数据本身.vue的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBa9pj4.html" rel="bookmark" class="title">UITextView仿微信输入</a>
					<div>
						UITextView仿微信输入 输入和删除文字的时候不会出现抖动,也不会出现一行文字显示一半的情况,代码中部分数据用的是死数据,用的时候要灵活运用,适当调整一下! #define textFont [ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWDRrl0.html" rel="bookmark" class="title">理解 Cinder 架构 - 每天5分钟玩转 OpenStack（45）</a>
					<div>
						从本节开始我们学习 OpenStack 的 Block Storage Service,Cinder 理解 Block Storage 操作系统获得存储空间的方式一般有两种: 通过某种协议(SAS,S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPZWmy3.html" rel="bookmark" class="title">java中的lis数组转为json数据</a>
					<div>
						第一个想到的办法就是 javascript中的replace 也就是先将list数组转为 字符串再对 字符串  replace 但是万万没想到javascript的replace函数在替换数据时, 默 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBbDeZM.html" rel="bookmark" class="title">tomcat7&lowbar;zip版manager用户名和密码配置</a>
					<div>
						下载apache-tomcat-7.0.47.zip,解压缩之后, 重新启动tomcat即可.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6lPOG3.html" rel="bookmark" class="title">golang实现dns域名解析（三）：响应报文分析</a>
					<div>
						前面说了构造请求发送报文,接下来我们好好研究下如何解析服务器端发回来的应答信息. 首先还是用前面的程序代码发一个请求,用抓包工具看看应答的内容有哪些: 截图的第一部分是返回信息的统计,表明这个返回的包 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kNXd7M.html" rel="bookmark" class="title">Vue&period;2&period;0&period;5-条件渲染</a>
					<div>
						v-if 在字符串模板中,如 Handlebars ,我们得像这样写一个条件块: &lt;!-- Handlebars 模板 --&gt; {{#if ok}} &lt;h1&gt;Yes&lt;/h ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OyzVgM.html" rel="bookmark" class="title">Windows Maven package时报错问题的解决</a>
					<div>
						google了一把,看到别人的说法是Stack size 不够大. Stack Space用来做方法的递归调用时压入Stack Frame.所以当递归调用太深的时候,就有可能耗尽Stack Space ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyoNWY3.html" rel="bookmark" class="title">python 基础 知识</a>
					<div>
						Python Python 是一种强类型 的解释型 动态型语言Python 对象中的不可变 数字,字符串,元组 ,对于不能改变的会创建一个新的                可变  列表 , 字典   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nbdxx0.html" rel="bookmark" class="title">php里 &bsol;r&bsol;n换行问题</a>
					<div>
						&lt;?php echo &quot;hello&quot;; echo &quot;\r\n&quot;; echo &quot;world&quot;; ?&gt; 在浏览器输出的是hello  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rp1V9M.html" rel="bookmark" class="title">TSP&plus;dp&plus;状态压缩的本质</a>
					<div>
						/* dis[1][2]=1;dis[1][3]=3;dis[1][4]=6; dis[2][3]=2;dis[2][4]=5; dis[3][4]=3; 二进制从右往左依次代表的1-n,0代表没有经 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
